// Includes
// The following define/undef is done only once in the project. It should be
// done before including the interface of the class deriving from
// Scroll (as follows).

#define __SCROLL_IMPL__
#include "include/OrxScroll.h"
#undef __SCROLL_IMPL__

#include "include/EnemyBug.h"

orxSTATUS OrxScroll::Bootstrap() const
{
    // Add "../data/config" to the list of locations that config files can be loaded from
    orxResource_AddStorage(orxCONFIG_KZ_RESOURCE_GROUP, "../data/config", orxFALSE);

    // Loads a specific config file
    orxConfig_Load("OrxScroll.ini");

    return orxSTATUS_FAILURE;
}

orxSTATUS OrxScroll::Init()
{
    orxSTATUS result = orxSTATUS_SUCCESS;

    for (orxU32 i = 0; i < 5; i++)
    {
        CreateObject("O-EnemyBug");
    }

    return result;
}

orxSTATUS OrxScroll::Run()
{
    orxSTATUS result = orxSTATUS_SUCCESS;

    return result;
}

void OrxScroll::Exit()
{
}

void OrxScroll::BindObjects()
{
    ScrollBindObject<EnemyBug>("O-EnemyBug");
}

int main(int argc, char **argv)
{
    // Executes game
    OrxScroll::GetInstance().Execute (argc, argv);

    // Done!
    return EXIT_SUCCESS;
}
